javax.lang.model.util

## Class ElementKindVisitor6<R,P>

- java.lang.Object
- - javax.lang.model.util.AbstractElementVisitor6<R,P>
  - - javax.lang.model.util.SimpleElementVisitor6<R,P>
    - - javax.lang.model.util.ElementKindVisitor6<R,P>

- Type Parameters:
    `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
    `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.
  All Implemented Interfaces:
    ElementVisitor<R,P>
  Direct Known Subclasses:
    ElementKindVisitor7

      @SupportedSourceVersion(value=RELEASE_6)
      public class ElementKindVisitor6<R,P>
      extends SimpleElementVisitor6<R,P>

  A visitor of program elements based on their kind with default behavior appropriate for the `RELEASE_6` source version. For elements `XYZ` that may have more than one kind, the `visitXYZ` methods in this class delegate to the `visitXYZKind` method corresponding to the first argument's kind. The `visitXYZKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

  Methods in this class may be overridden subject to their general contract. Note that annotating methods in concrete subclasses with `@Override` will help ensure that methods are overridden as intended.

  WARNING: The `ElementVisitor` interface implemented by this class may have methods added to it or the `ElementKind` `enum` used in this case may have constants added to it in the future to accommodate new, currently unknown, language structures added to future versions of the Java™ programming language. Therefore, methods whose names begin with `"visit"` may be added to this class in the future; to avoid incompatibilities, classes which extend this class should not declare any instance methods with names beginning with `"visit"`.

  When such a new visit method is added, the default implementation in this class will be to call the `visitUnknown` method. A new abstract element kind visitor class will also be introduced to correspond to the new language level; this visitor will have different default behavior for the visit method in question. When the new visitor is introduced, all or portions of this visitor may be deprecated.

  Since:
    1.6
  See Also:
    `ElementKindVisitor7`

- - ### Field Summary

    - ### Fields inherited from class javax.lang.model.util.SimpleElementVisitor6

      `DEFAULT_VALUE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ElementKindVisitor6()` Constructor for concrete subclasses; uses `null` for the default value.
    `protected` | `ElementKindVisitor6(R defaultValue)` Constructor for concrete subclasses; uses the argument for the default value.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `R` | `visitExecutable(ExecutableElement e, P p)` Visits an executable element, dispatching to the visit method for the specific kind of executable, `CONSTRUCTOR`, `INSTANCE_INIT`, `METHOD`, or `STATIC_INIT`.
    `R` | `visitExecutableAsConstructor(ExecutableElement e, P p)` Visits a `CONSTRUCTOR` executable element by calling `defaultAction`.
    `R` | `visitExecutableAsInstanceInit(ExecutableElement e, P p)` Visits an `INSTANCE_INIT` executable element by calling `defaultAction`.
    `R` | `visitExecutableAsMethod(ExecutableElement e, P p)` Visits a `METHOD` executable element by calling `defaultAction`.
    `R` | `visitExecutableAsStaticInit(ExecutableElement e, P p)` Visits a `STATIC_INIT` executable element by calling `defaultAction`.
    `R` | `visitPackage(PackageElement e, P p)` Visits a package element.
    `R` | `visitType(TypeElement e, P p)` Visits a type element, dispatching to the visit method for the specific kind of type, `ANNOTATION_TYPE`, `CLASS`, `ENUM`, or `INTERFACE`.
    `R` | `visitTypeAsAnnotationType(TypeElement e, P p)` Visits an `ANNOTATION_TYPE` type element by calling `defaultAction`.
    `R` | `visitTypeAsClass(TypeElement e, P p)` Visits a `CLASS` type element by calling `defaultAction`.
    `R` | `visitTypeAsEnum(TypeElement e, P p)` Visits an `ENUM` type element by calling `defaultAction`.
    `R` | `visitTypeAsInterface(TypeElement e, P p)` Visits an `INTERFACE` type element by calling `defaultAction`.
    `R` | `visitTypeParameter(TypeParameterElement e, P p)` Visits a type parameter element.
    `R` | `visitVariable(VariableElement e, P p)` Visits a variable element, dispatching to the visit method for the specific kind of variable, `ENUM_CONSTANT`, `EXCEPTION_PARAMETER`, `FIELD`, `LOCAL_VARIABLE`, `PARAMETER`, or `RESOURCE_VARIABLE`.
    `R` | `visitVariableAsEnumConstant(VariableElement e, P p)` Visits an `ENUM_CONSTANT` variable element by calling `defaultAction`.
    `R` | `visitVariableAsExceptionParameter(VariableElement e, P p)` Visits an `EXCEPTION_PARAMETER` variable element by calling `defaultAction`.
    `R` | `visitVariableAsField(VariableElement e, P p)` Visits a `FIELD` variable element by calling `defaultAction`.
    `R` | `visitVariableAsLocalVariable(VariableElement e, P p)` Visits a `LOCAL_VARIABLE` variable element by calling `defaultAction`.
    `R` | `visitVariableAsParameter(VariableElement e, P p)` Visits a `PARAMETER` variable element by calling `defaultAction`.
    `R` | `visitVariableAsResourceVariable(VariableElement e, P p)` Visits a `RESOURCE_VARIABLE` variable element by calling `visitUnknown`.

    - ### Methods inherited from class javax.lang.model.util.SimpleElementVisitor6

      `defaultAction`

    - ### Methods inherited from class javax.lang.model.util.AbstractElementVisitor6

      `visit, visit, visitUnknown`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ElementKindVisitor6

          protected ElementKindVisitor6()

      Constructor for concrete subclasses; uses `null` for the default value.

    - #### ElementKindVisitor6

          protected ElementKindVisitor6(R defaultValue)

      Constructor for concrete subclasses; uses the argument for the default value.
      Parameters:
        `defaultValue` - the value to assign to `SimpleElementVisitor6.DEFAULT_VALUE`

  - ### Method Detail

    - #### visitPackage

          public R visitPackage(PackageElement e,
                       P p)

      Visits a package element. This implementation calls `defaultAction`. The element argument has kind `PACKAGE`.
      Specified by:
        `visitPackage` in interface `ElementVisitor<R,P>`
      Overrides:
        `visitPackage` in class `SimpleElementVisitor6<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitType

          public R visitType(TypeElement e,
                    P p)

      Visits a type element, dispatching to the visit method for the specific kind of type, `ANNOTATION_TYPE`, `CLASS`, `ENUM`, or `INTERFACE`.
      Specified by:
        `visitType` in interface `ElementVisitor<R,P>`
      Overrides:
        `visitType` in class `SimpleElementVisitor6<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of the kind-specific visit method

    - #### visitTypeAsAnnotationType

          public R visitTypeAsAnnotationType(TypeElement e,
                                    P p)

      Visits an `ANNOTATION_TYPE` type element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitTypeAsClass

          public R visitTypeAsClass(TypeElement e,
                           P p)

      Visits a `CLASS` type element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitTypeAsEnum

          public R visitTypeAsEnum(TypeElement e,
                          P p)

      Visits an `ENUM` type element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitTypeAsInterface

          public R visitTypeAsInterface(TypeElement e,
                               P p)

      Visits an `INTERFACE` type element by calling `defaultAction`. .
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitVariable

          public R visitVariable(VariableElement e,
                        P p)

      Visits a variable element, dispatching to the visit method for the specific kind of variable, `ENUM_CONSTANT`, `EXCEPTION_PARAMETER`, `FIELD`, `LOCAL_VARIABLE`, `PARAMETER`, or `RESOURCE_VARIABLE`.
      Specified by:
        `visitVariable` in interface `ElementVisitor<R,P>`
      Overrides:
        `visitVariable` in class `SimpleElementVisitor6<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of the kind-specific visit method

    - #### visitVariableAsEnumConstant

          public R visitVariableAsEnumConstant(VariableElement e,
                                      P p)

      Visits an `ENUM_CONSTANT` variable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitVariableAsExceptionParameter

          public R visitVariableAsExceptionParameter(VariableElement e,
                                            P p)

      Visits an `EXCEPTION_PARAMETER` variable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitVariableAsField

          public R visitVariableAsField(VariableElement e,
                               P p)

      Visits a `FIELD` variable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitVariableAsLocalVariable

          public R visitVariableAsLocalVariable(VariableElement e,
                                       P p)

      Visits a `LOCAL_VARIABLE` variable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitVariableAsParameter

          public R visitVariableAsParameter(VariableElement e,
                                   P p)

      Visits a `PARAMETER` variable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitVariableAsResourceVariable

          public R visitVariableAsResourceVariable(VariableElement e,
                                          P p)

      Visits a `RESOURCE_VARIABLE` variable element by calling `visitUnknown`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `visitUnknown`
      Since:
        1.7

    - #### visitExecutable

          public R visitExecutable(ExecutableElement e,
                          P p)

      Visits an executable element, dispatching to the visit method for the specific kind of executable, `CONSTRUCTOR`, `INSTANCE_INIT`, `METHOD`, or `STATIC_INIT`.
      Specified by:
        `visitExecutable` in interface `ElementVisitor<R,P>`
      Overrides:
        `visitExecutable` in class `SimpleElementVisitor6<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of the kind-specific visit method

    - #### visitExecutableAsConstructor

          public R visitExecutableAsConstructor(ExecutableElement e,
                                       P p)

      Visits a `CONSTRUCTOR` executable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitExecutableAsInstanceInit

          public R visitExecutableAsInstanceInit(ExecutableElement e,
                                        P p)

      Visits an `INSTANCE_INIT` executable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitExecutableAsMethod

          public R visitExecutableAsMethod(ExecutableElement e,
                                  P p)

      Visits a `METHOD` executable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitExecutableAsStaticInit

          public R visitExecutableAsStaticInit(ExecutableElement e,
                                      P p)

      Visits a `STATIC_INIT` executable element by calling `defaultAction`.
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

    - #### visitTypeParameter

          public R visitTypeParameter(TypeParameterElement e,
                             P p)

      Visits a type parameter element. This implementation calls `defaultAction`. The element argument has kind `TYPE_PARAMETER`.
      Specified by:
        `visitTypeParameter` in interface `ElementVisitor<R,P>`
      Overrides:
        `visitTypeParameter` in class `SimpleElementVisitor6<R,P>`
      Parameters:
        `e` - the element to visit
        `p` - a visitor-specified parameter
      Returns:
        the result of `defaultAction`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2014, Oracle and/or its affiliates. All rights reserved.